/* Intel Atom/32 gmp-mparam.h -- Compiler/machine parameter header file.

Copyright 1991, 1993, 1994, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007,
2008, 2009 Free Software Foundation, Inc.

This file is part of the GNU MP Library.

The GNU MP Library is free software; you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation; either version 3 of the License, or (at your
option) any later version.

The GNU MP Library is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with the GNU MP Library.  If not, see http://www.gnu.org/licenses/.  */

#define GMP_LIMB_BITS 32
#define BYTES_PER_MP_LIMB 4

/* Generated by tuneup.c, 2009-12-28, gcc 4.4 */

#define MOD_1_NORM_THRESHOLD                 3
#define MOD_1_UNNORM_THRESHOLD               7
#define MOD_1N_TO_MOD_1_1_THRESHOLD         19
#define MOD_1U_TO_MOD_1_1_THRESHOLD          7
#define MOD_1_1_TO_MOD_1_2_THRESHOLD        11
#define MOD_1_2_TO_MOD_1_4_THRESHOLD        18
#define PREINV_MOD_1_TO_MOD_1_THRESHOLD     38
#define USE_PREINV_DIVREM_1                  1
#define DIVEXACT_1_THRESHOLD                 0  /* always (native) */
#define BMOD_1_TO_MOD_1_THRESHOLD          144

#define MUL_TOOM22_THRESHOLD                16
#define MUL_TOOM33_THRESHOLD                66
#define MUL_TOOM44_THRESHOLD               171
#define MUL_TOOM6H_THRESHOLD               258
#define MUL_TOOM8H_THRESHOLD               357

#define MUL_TOOM32_TO_TOOM43_THRESHOLD     113
#define MUL_TOOM32_TO_TOOM53_THRESHOLD     124
#define MUL_TOOM42_TO_TOOM53_THRESHOLD     113
#define MUL_TOOM42_TO_TOOM63_THRESHOLD     129

#define SQR_BASECASE_THRESHOLD               0  /* always (native) */
#define SQR_TOOM2_THRESHOLD                 16
#define SQR_TOOM3_THRESHOLD                113
#define SQR_TOOM4_THRESHOLD                193
#define SQR_TOOM6_THRESHOLD                254
#define SQR_TOOM8_THRESHOLD                381

#define MULMOD_BNM1_THRESHOLD               13
#define SQRMOD_BNM1_THRESHOLD               11

#define MUL_FFT_TABLE  { 336, 672, 896, 2560, 10240, 24576, 98304, 393216, 0 }
#define MUL_FFT_MODF_THRESHOLD             352
#define MUL_FFT_THRESHOLD                 7168

#define SQR_FFT_TABLE  { 336, 672, 896, 2560, 6144, 24576, 98304, 393216, 0 }
#define SQR_FFT_MODF_THRESHOLD             296
#define SQR_FFT_THRESHOLD                 3840

#define MULLO_BASECASE_THRESHOLD             0  /* always */
#define MULLO_DC_THRESHOLD                  56
#define MULLO_MUL_N_THRESHOLD             8648

#define DC_DIV_QR_THRESHOLD                 58
#define DC_DIVAPPR_Q_THRESHOLD             220
#define DC_BDIV_QR_THRESHOLD                56
#define DC_BDIV_Q_THRESHOLD                136

#define INV_MULMOD_BNM1_THRESHOLD           30
#define INV_NEWTON_THRESHOLD               260
#define INV_APPR_THRESHOLD                 244

#define BINV_NEWTON_THRESHOLD              264
#define REDC_1_TO_REDC_N_THRESHOLD          63

#define MU_DIV_QR_THRESHOLD               1607
#define MU_DIVAPPR_Q_THRESHOLD            1607
#define MUPI_DIV_QR_THRESHOLD              293
#define MU_BDIV_QR_THRESHOLD              1547
#define MU_BDIV_Q_THRESHOLD               1577

#define MATRIX22_STRASSEN_THRESHOLD         17
#define HGCD_THRESHOLD                     109
#define GCD_DC_THRESHOLD                   372
#define GCDEXT_DC_THRESHOLD                275
#define JACOBI_BASE_METHOD                   2

#define GET_STR_DC_THRESHOLD                14
#define GET_STR_PRECOMPUTE_THRESHOLD        27
#define SET_STR_DC_THRESHOLD               270
#define SET_STR_PRECOMPUTE_THRESHOLD       860
